import '../App.css';
import 'smart-webcomponents-react/source/styles/smart.default.css';
import { useEffect, useState } from 'react';
import { Grid } from 'smart-webcomponents-react/grid';

type Props = {
    appearance: string,
    selection: string,
    sorting: string,
    dataSource: JSON,
    columns: string
};

const appearance_Data = {
    alternationStart: 0,
    alternationCount: 5
}

const filtering_Data = {
    enabled: true
}

const sorting_Data = {
    enabled: true
}

const paging = {
    enabled: true,
    pageSize: 10,
    pageIndex: 0
};

const pager = {
    visible: true,
    pageSizeSelector: {
        visible: true
    },
    pageIndexSelectors: {
        dataSource: 3
    }
};

const layout = {
    rowHeight: 'auto',
    allowCellsWrap: true
};


const dataSource_Data = new window.Smart.DataAdapter({
    dataSource: [
        {
            "viewResolution":"View Reolution",
            "id": "1",
            "schoolName": "School A",
            "schoolCode": "786786782",
            "recordId": "659898",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-1",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School B",
            "schoolCode": "786745432",
            "recordId": "158753",
            "actualValue": "[No];",
            "type": "Warning",
            "errorCode": "675",
            "errorDescription": "This is the space for error description-2",
            "errorGroup": "Teacher"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School C",
            "schoolCode": "786878772",
            "recordId": "655454",
            "actualValue": "[Yes];",
            "type": "Error",
            "errorCode": "790",
            "errorDescription": "This is the space for error description-4",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School D",
            "schoolCode": "123112316",
            "recordId": "561312",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-3",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School A",
            "schoolCode": "786786782",
            "recordId": "659898",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-1",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School B",
            "schoolCode": "786745432",
            "recordId": "6580753",
            "actualValue": "[No];",
            "type": "Warning",
            "errorCode": "675",
            "errorDescription": "This is the space for error description-2",
            "errorGroup": "Teacher"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School C",
            "schoolCode": "786878772",
            "recordId": "655454",
            "actualValue": "[Yes];",
            "type": "Error",
            "errorCode": "790",
            "errorDescription": "This is the space for error description-4",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School D",
            "schoolCode": "123112316",
            "recordId": "561312",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-3",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School A",
            "schoolCode": "786786782",
            "recordId": "659898",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-1",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School B",
            "schoolCode": "786745432",
            "recordId": "6580753",
            "actualValue": "[No];",
            "type": "Warning",
            "errorCode": "675",
            "errorDescription": "This is the space for error description-2",
            "errorGroup": "Teacher"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School C",
            "schoolCode": "786878772",
            "recordId": "655454",
            "actualValue": "[Yes];",
            "type": "Error",
            "errorCode": "790",
            "errorDescription": "This is the space for error description-4",
            "errorGroup": "Student"
        },
        {
            "viewResolution": "View Reolution",
            "id": "1",
            "schoolName": "School D",
            "schoolCode": "123112316",
            "recordId": "561312",
            "actualValue": "[No];",
            "type": "Error",
            "errorCode": "156",
            "errorDescription": "This is the space for error description-3",
            "errorGroup": "Student"
        }
    ],
    dataFields: [
        'viewResolution:string',
        'schoolName:string',
        'schoolCode:string',
        'recordId:string',
        'actualValue:string',
        'type:string',
        'errorCode:string',
        'errorDescription:string',
        'errorGroup:string'
    ]
})

const columns_Data = [
    { label: '', dataField: 'viewResolution', width: 90},
    { label: 'School Name', dataField: 'schoolName' },
    { label: 'School Code', dataField: 'schoolCode' },
    { label: 'Record UID', dataField: 'recordId' },
    { label: 'Actual Value', dataField: 'actualValue' },
    { label: 'Type', dataField: 'type' },
    { label: 'Error #', dataField: 'errorCode' },
    { label: 'Error Description', dataField: 'errorDescription' },
    { label: 'Error Group', dataField: 'errorGroup' }
];

export default function DataGridComponent({ appearance, selection, sorting, dataSource, columns }: Props) {
    return (
        <div className="row">
            <div className="col-sm-12">
                <Grid appearance={appearance_Data}
                    filtering={filtering_Data}
                    sorting={sorting_Data}
                    dataSource={dataSource_Data}
                    columns={columns_Data}
                    allowPaging={true} paging={paging}
                    pager={pager}
                    layout={layout}
                    allowTextWrap={true}
                    justifyContent="center"></Grid>
            </div>
        </div>
    );
};

