import './index.css';
import App from './App';
import reportWebVitals from './reportWebVitals';
import React, { FunctionComponent, useEffect, ReactElement } from 'react';
import * as ReactDOM from 'react-dom/client';
import Checklist from './components/CardComponent';
import ComingSoonAndPastCard from './components/ComingSoonAndPastCardComponent';
import r2wc from "@r2wc/react-to-web-component";
import reactToWebComponent from "react-to-webcomponent";
import Slider from './components/SliderComponent';
import DataGrid from './components/DataGridComponent';
import KendoDataGrid from './components/KendoDataGridComponent';
import useEmblaCarousel, { EmblaOptionsType } from "embla-carousel-react";

const WebComponentWrapper: FunctionComponent<{ header: string, opendate: string, duedate: string, closedate: string, description: string, index: number }> = ({ header, opendate, duedate, closedate, description, index }) => {
    useEffect(() => {
        console.log('header: ', header);
        console.log('opendate: ', opendate);
        console.log('duedate: ', duedate);
        console.log('closedate: ', closedate);
        console.log('description: ', description);
        console.log('index: ', index);
    }, [header, opendate, duedate, closedate, description, index]);
    return (
        <Checklist header={header} opendate={opendate} duedate={duedate} closedate={closedate} description={description} index={index} />
    );
}
const wcChecklist = r2wc(WebComponentWrapper, {
    props: {
        header: 'string',
        opendate: 'string',
        duedate: 'string',
        closedate: 'string',
        description: 'string',
        index: 'number'
    },
});
customElements.define('custom-app-card', wcChecklist);

const WebComponentComingSoonAndPastCard: FunctionComponent<{ header: string, datetype: string, date: string, color: string, description: string }> = ({ header, datetype, date, color, description }) => {
    useEffect(() => {
        console.log('header: ', header);
        console.log('datetype: ', datetype);
        console.log('date: ', date);
        console.log('color: ', color);
        console.log('description: ', description);
    }, [header, datetype, date, color, description]);
    return (
        <ComingSoonAndPastCard header={header} datetype={datetype} date={date} color={color} description={description} />
    );
}
const wcComingSoonAndPastCardList = r2wc(WebComponentComingSoonAndPastCard, {
    props: {
        header: 'string',
        datetype: 'string',
        date: 'string',
        color: 'string',
        description: 'string'
    },
});
customElements.define('coming-soon-and-past-card', wcComingSoonAndPastCardList);

const WebComponentSlider: FunctionComponent<{ children: any }> = ({ children }) => {
    useEffect(() => {
        console.log('children: ', children);
    }, [children]);
    return (
        <Slider children={children} />
    );
}
const wcSlider = r2wc(Slider, {
    props: {
        children: 'ReactNode',
    },
});
customElements.define('custom-slider', wcSlider);

const WebComponentGrid: FunctionComponent<{ appearance: string, selection: string, sorting: string, dataSource: JSON, columns: string }> = ({ appearance, selection, sorting, dataSource, columns }) => {
    useEffect(() => {
        console.log('appearance: ', appearance);
        console.log('selection: ', selection);
        console.log('sorting: ', sorting);
        console.log('dataSource: ', dataSource);
        console.log('columns: ', columns);
    }, [appearance, selection, sorting, dataSource, columns]);
    return (
        <DataGrid appearance={appearance} selection={selection} sorting={sorting} dataSource={dataSource} columns={columns} />
    );
}
const wcDataGridList = r2wc(WebComponentGrid, {
    props: {
        appearance: 'string',
        selection: 'string',
        sorting: 'string',
        dataSource: 'Smart.DataAdapter',
        columns: 'string'
    },
});
customElements.define('custom-grid', wcDataGridList);

const WebComponentKendoGrid: FunctionComponent = () => {
    useEffect(() => {
    }, []);
    return (
        <KendoDataGrid />
    );
}
const wcKendoDataGridList = r2wc(WebComponentKendoGrid, {
});
customElements.define('custom-kendo-data-grid', wcKendoDataGridList);
